package pars;

import java.io.*;
import java.util.*;
import java.nio.*;

public class Parser {
	private FileReader spawnFile;
	private BufferedReader spawnBuff;
	private InputStream Input;
	private DataOutputStream Output;
	private DataInputStream data;
	private float maxX = 0;
	private float maxY = 0;
	private float maxZ = 0;

	
	public Parser()
	{
		try {
			Input = new FileInputStream("src/terrain_derev_amk8.thm");
			data = new DataInputStream(this.Input);
			Output = new DataOutputStream(new FileOutputStream("terrain_derev_amk8-n.thm"));
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}
	
	public Parser(String Fileinput)
	{
		if(!Fileinput.equals("dummy"))
		{
			try {
				Input = new FileInputStream("src/"+Fileinput);
				data = new DataInputStream(this.Input);
				Output = new DataOutputStream(new FileOutputStream("output/"+Fileinput));
				
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		else
		{
			//on cree une instance vide
			//System.out.println("dummy!");
		}
	}
	
	
	public Parser(String Fileinput, String Fileoutput)
	{
		try {
			spawnFile = new FileReader("src/"+Fileinput);
			spawnBuff = new BufferedReader(spawnFile);
			
			//spawnWrite = new PrintWriter("alive_lxx.ltx");
			//spawnWbuff = new StringWriter(spawnWrite);
			Output = new DataOutputStream(new FileOutputStream(Fileoutput));
			
			
		
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	
	
	public static void main(String[] args)
	{
		File fichier = new File("src");
		//st contient une liste des noms des fichiers contenus dans le dossier "src"
		String[] st = fichier.list();
		int i = 0;
		int j = 0;
		Parser pars = new Parser("dummy");
		//nettoyons le fichier de sortie avant le debut d'analyse
		pars.cleanOutput();
		while(i<st.length)
		{
			//filtrons les resultats
			if(st[i].contains(".thm"))
			{
				System.out.println("file : " + st[i]);
				j++;
				pars.ThmParser(st[i]);
			}
			else
			{
				//skip
			}
			i++;
		}
		System.out.println("Listed  " + i + " files in src folder");
		System.out.println("Converted  " + j + " files to output folder");
		
	}
	
	public void ThmParser(String filename)
	{
		Parser pars = new Parser(filename);
		//find image chunk, read it, and skip the rest
		//d'abord lire les 14 bytes
		//puis lire 4 bytes de taille
		//skip the read size, and finish the file
		try {
			byte[] donnees = new byte[10];
			pars.data.read(donnees);
			pars.Output.write(donnees);
			
			//4 bytes inutiles, a supprimer
			//donnees = new byte[4];
			//pars.data.read(donnees);
			pars.data.skip(4);
			
			donnees = new byte[4];
			pars.data.read(donnees);
			
			int val = 0;
			val = pars.decodeSize(donnees);
			//val = pars.data.readInt();
			System.out.println("skip " + (val + 8) + " bytes" + " "+'\r'+'\n' + " ");
			
			//Skip
			pars.data.skip(val);
			int count = 0;
			byte b = 0;
			while(pars.data.available() > 0)
			{
				b = pars.data.readByte();
				pars.Output.write(b);
				
				//System.out.println("count  " + count + ", b " + b);
				count++;
			}
		} catch (IOException e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	//lit 4 bytes et en decode la valeur de integer correspondante,
	//lue de droite a gauche
	public int decodeSize(byte[] tab)
	{
		int res = 0;
		res = (((tab[3] & 0xff) << 24) | ((tab[2] & 0xff) << 16) |
				  ((tab[1] & 0xff) << 8) | (tab[0] & 0xff));
		
		return res;
	}
	
	//nettoie le contenu du dossier output
	public void cleanOutput()
	{
		File sortie = new File("output");
		File[] contenu = sortie.listFiles();
		int i = 0;
		while(i<contenu.length)
		{
			contenu[i].delete();
			i++;
		}
	}
	
	//***********************************************************
	
	public float ConvertToFloat(byte[] tab)
	{
		int i = 3;
		byte[] buf = new byte[4];
		//inversons ce tableau
		while(i>=0)
		{
			buf[3-i] = tab[i];
			i=i-1;
		}
		ByteBuffer Bbuf = ByteBuffer.wrap(buf);
		float f = Bbuf.getFloat();
		return f;
	}
	
	public void SpawnAdder(Parser pars, int val)
	{
		
		String lu;
		String temp = "";
		while(true)
		{
			try {
				lu = pars.spawnBuff.readLine();
				if (lu == null)
				{
					break;
				}
				if(lu.contains("game_vertex_id = "))
				{
					if(lu.contains("dest_game_vertex_id = "))
					{
						System.out.println("---------------------");
						System.out.println("vertex actuel  :  "+lu);
						temp = lu.substring(22);
						//System.out.println(temp);
						int i = Integer.parseInt(temp);
						i = i+val;
						lu = "dest_game_vertex_id = "+""+i;
						System.out.println("nouveau vertex :  "+lu);
						System.out.println(" ");
					}
					//cas d'un way point
					else if(lu.contains(":game_vertex_id ="))
					{
						System.out.println("*********************");
						System.out.println("------way_point------");
						System.out.println("vertex actuel :  "+lu);
						String nom = "";
						nom = lu.substring(0, lu.indexOf(":")+1);
						temp = lu.substring(lu.indexOf(":")+1);
						temp = temp.substring(17);
						//System.out.println(temp);
						int i = Integer.parseInt(temp);
						i = i+val;
						lu = nom + "game_vertex_id = "+""+i;
						System.out.println("nouveau vertex :  "+lu);
						System.out.println(" ");
					}
					else
					{
						System.out.println("---------------------");
						System.out.println("vertex actuel  :  "+lu);
						temp = lu.substring(17);
						//System.out.println(temp);
						int i = Integer.parseInt(temp);
						i = i+val;
						lu = "game_vertex_id = "+""+i;
						System.out.println("nouveau vertex :  " + lu);
						System.out.println(" ");
					}
				}
				//pars.spawnWbuff.write(lu);
				//pars.spawnWbuff.newLine();
				pars.Output.writeBytes(lu);
				pars.Output.writeBytes(""+'\r'+'\n');
				
				
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	
	
	public void WriteSpawn(ArrayList<ArrayList<Integer>> spawn, Parser pars)
	{
		int value = 0;
		for(ArrayList<Integer> section : spawn)
		{
			//pretraiter dans une sous methode!!
			ArrayList<Integer> section2 = pars.NouveauOrdre(section,value);
			//System.out.println("value  : "+ value);
			//ecriture de la setion
			for(int i : section2)
			{
				try 
				{
					pars.Output.write(i);
					
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			value++;
		}
	}
	
	public ArrayList<Integer> NouveauOrdre(ArrayList<Integer> section, int value)
	{
		int i = 0;
		int[] tab = this.ConvertToAscii2(value);
		while(i<4)
		{
			//on modifie la section
			//System.out.println("tab[i]   "+ tab[i]);
			section.set(i, tab[i]);
			//System.out.println("section *****   "+ section.get(i));
			i++;
		}
		
		return section;
	}
	
	
	
	//Attention, le String est une structure inapropriee pour stocker les 
	//donnees lues
	public ArrayList<ArrayList<Integer>> PointsReader4()
	{
		Parser pars = new Parser();
		//ArrayList<String> grafs= new ArrayList<String>();
		ArrayList<ArrayList<Integer>> grafs2= new ArrayList<ArrayList<Integer>>();
		ArrayList<Integer> ligne = new ArrayList<Integer>();
		int counter = 0;
		int count = 0;
		int size = 0;
		//String recu = "";
		//String taille = "";
		Boolean flag = false;
		int ch = 0;
		
		while(ch != -1)
		{
			try 
			{
				
				
				ch = pars.Input.read();
				count++;
						if(!flag)
						{
						//System.out.println("!flag");
						
							if(counter < 7)
							{
								ligne.add(ch);
								//recu = recu + ch;//ligne obsolete
								counter++;
							}
							//on a lu les 7 premiers bits
							else
							{
								ligne.add(ch);
								//recu = recu + ch;//ligne obsolete
								flag = true;
								counter = 0;
								
								//decryptons la taille
								
								ArrayList<Integer> chunk = new ArrayList<Integer>();
								int k = 4;
								while(k<8)
								{
									chunk.add(ligne.get(k));
									k++;
								}
								size = this.ConvertToDec2(chunk);
								//taille = recu.substring(4, 8);//ligne obsolete
								//size = this.ConvertToDec(taille);//ligne obsolete
								//System.out.println("taille " + size);
							}
						
							
						}
						//on doit lire la section
						else
						{
							if((size-1)>0)
							{
								//System.out.println("size " + size);
								
									//System.out.println("size "+ size);
								ligne.add(ch);
								//recu = recu + ch;//ligne obsolete
								size--;
									
								
							}
							else
							{
								ligne.add(ch);
								//recu = recu + ch;//ligne obsolete
								
								//la section est lue
								flag = false;
								
								//la section lue est rajoutee aux autres
								//grafs.add(recu);//ligne obsolete
								grafs2.add(ligne);
								//effacer recu
								//recu = "";//obsolete
								
								//reinialiser ligne!
								ligne = new ArrayList<Integer>();						}
						}
					
				
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		return grafs2;
	}
	
	
	
	
	//chercher le bon charset, celui ci ne satisfait pas a tous les cas rencontres.
	public int ConvertToDec(String bytes)
	{
		int i = 0;
		int res = 0;
		String[] tab = new String[4];
		int charVal = 0;
		String ens = "";
		//etape 1 : encodage des valeurs en hex
		while(i <= bytes.length()-1)
		{
			charVal = bytes.charAt(i);
			//System.out.println("charval " + charVal);
			tab[i] = Integer.toHexString(charVal);
			//System.out.println("tab[" +i+"] " + tab[i]);
			i++;
		}
		//etape 2 : calcul de la longueur en base 10
		i = 3;//longueur de tableau -1
		while(i>=0)
		{
			String buf = "";
			buf = tab[i];
			if(tab[i].length()<2)
			{
				buf = "" + 0 + tab[i];
			}
			ens = ens + buf;
			i = i-1;
		}
		//System.out.println(ens);
		res = Integer.parseInt(ens, 16);
		//System.out.println("" + res);
		return res;
	}
	
	//pre : longueur de "data" est 4
	public int ConvertToDec2(ArrayList<Integer> data)
	{
		String bytes="";
		int i = 0;
		int res = 0;
		String[] tab = new String[4];
		int charVal = 0;
		String ens = "";
		//etape 1 : encodage des valeurs en hex
		//boucle while obsolete 
		/*while(i <= bytes.length()-1)
		{
			charVal = bytes.charAt(i);
			System.out.println("charval " + charVal);
			tab[i] = Integer.toHexString(charVal);
			System.out.println("tab[" +i+"] " + tab[i]);
			i++;
		}*/
		//remplacer par boucle for
		for(int current : data)
		{
			tab[i] = Integer.toHexString(current);
			//System.out.println("tab[" +i+"] " + tab[i]);
			i++;
		}
		
		
		
		//etape 2 : calcul de la longueur en base 10
		//etape valable
		i = 3;//longueur de tableau -1
		while(i>=0)
		{
			String buf = "";
			buf = tab[i];
			if(tab[i].length()<2)
			{
				buf = "" + 0 + tab[i];
			}
			ens = ens + buf;
			i = i-1;
		}
		//System.out.println(ens);
		res = Integer.parseInt(ens, 16);
		//System.out.println("" + res);
		return res;
	}
	
	
	
	//convertisse l'entier passe en parametre, en code ascii,
	//en passant par la valeur hexadecimale. etait char[]
	public String ConvertToAscii(int data)
	{
		//first conversion to hex value of a decimal number
		String res = Integer.toHexString(data);
		System.out.println(res);
		
	   /* maintenant on doit recopier le string obtenu dans un tableau de 4 elements
		* en inversant l'ordre des caracteres contenus dans le string,
		* et en ajoutant les zeros necessaires.
		*/
		
		int string_i = 0;
		int tab_i = 0;
		char[] tab = new char[4];
		int index = res.length()-1;
		String[] tabBuf = new String[4];
		while(string_i<= 3)
		{
			 tabBuf[string_i] = "00";
			 tab[string_i] = 0;
			 string_i++;
		}
		//reinscrire le string en un tableau de 4 elements
		String temp = res;
		while(index >= 0 )
		{
			if(index-1 >0) 
				tabBuf[tab_i] = "" + temp.charAt(index-1)+ temp.charAt(index);
			else
			{
				tabBuf[tab_i] = "0" + temp.charAt(index);
			}
			//System.out.println("tabBuf "+tabBuf[tab_i]);
			if(temp.length()>1)
			{
				temp = temp.substring(0, temp.length()-2);
			}
			else
				break;
			tab_i = tab_i+1;
			index = temp.length()-1;
			
		}
		tab_i = 3;
		//maintenant on a un tableau contenant des valeurs hexadecimales
		//il nous le faut convertir en chars ascii
		index = 0;
		res = "";
		while(index<= 3)
		{
			//System.out.println(tabBuf[index]);
			tab[index] = (char)Integer.parseInt(tabBuf[index], 16);
			res = res + tab[index];
			//System.out.println("tab "+tab[index]);
			index++;
		}
		//System.out.println("res "+res);
		return res;
	}
	
	
	public int[] ConvertToAscii2(int data)
	{
		//first conversion to hex value of a decimal number
		String res = Integer.toHexString(data);
		//System.out.println("after hex   "+res);
		
	   /* maintenant on doit recopier le string obtenu dans un tableau de 4 elements
		* en inversant l'ordre des caracteres contenus dans le string,
		* et en ajoutant les zeros necessaires.
		*/
		
		int string_i = 0;
		int tab_i = 0;
		int[] tab = new int[4];
		int index = res.length()-1;
		String[] tabBuf = new String[4];
		while(string_i<= 3)
		{
			 tabBuf[string_i] = "00";
			 tab[string_i] = 0;
			 string_i++;
		}
		//reinscrire le string en un tableau de 4 elements
		String temp = res;
		while(index >= 0 )
		{
			if(res.length()>2)
			{
				if(index-1>0) 
					tabBuf[tab_i] = "" + temp.charAt(index-1)+ temp.charAt(index);
				else
				{
					tabBuf[tab_i] = "0" + temp.charAt(index);
				}
				//System.out.println("tabBuf " + tab_i+ "  "+tabBuf[tab_i]);
				if(temp.length()>1)
				{
					temp = temp.substring(0, temp.length()-2);
				}
				else
					break;
				tab_i = tab_i+1;
				index = temp.length()-1;
			}
			else
			{
				if(res.length()==2)
				{
					tabBuf[tab_i] = "" + temp.charAt(index-1)+ temp.charAt(index);
				}
				
				else
				{
					tabBuf[tab_i] = "" + temp.charAt(index);
				}
				break;
			}
			
			
		}
		tab_i = 3;
		//maintenant on a un tableau contenant des valeurs hexadecimales
		//il nous le faut convertir en chars ascii
		index = 0;
		res = "";
		while(index<= 3)
		{
			//System.out.println(tabBuf[index]);
			tab[index] = Integer.parseInt(tabBuf[index], 16);
			//res = res + tab[index];
			//System.out.println("tab "+tab[index]);
			index++;
		}
		//System.out.println("res "+res);
		return tab;
	}
	
	
	public String NomReader(String ligne)
	{
		String nom = "";
		nom = ligne.substring(22);
		//System.out.println("nom " +nom);
		char u = 0;
		int i = 0;
		while(nom.charAt(i) != u)
		{
			i++;
		}
		//System.out.println("" + i);
		nom = nom.substring(0, i);
		//System.out.println("nom " +nom);
		
		return nom;
	}
	
	
	/*
	 * structure de l'en tete de fichier a lire : 
	 * Introduction : 
	 * 36 bytes a passer
	 * lire 4 bytes indiquant la taille de la section des donnees personnelles 	 
	 * lire le nombre des bytes indique par la taille precedente
	 * 20 bytes a passer
	 * debut des sections d'objets
	 * 
	 * 
	 * fin du fichier :
	 * la derniere partie du fichier est indiquee par la sequence suivante 
	 * 01 10 00 00 02 00 00 00
	 */
	public ArrayList<byte[]> ObjParser()
	{
		Parser pars = new Parser();
		ArrayList<byte[]> results = new ArrayList<byte[]>();
		Boolean flagObj = false;
		try 
		{
			while(pars.data.available() > 0)
			{
				if (flagObj)
				{
					//lire 4 bytes, puis encore 4 et decrypter la taille
					//verifier si on a atteint la fin de la section des objets
					//lire la section indique par cette taille et ainsi de suite
					byte[] donnees = new byte[8];
					int[] size = new int[8];
					//pars.data.read(donnees);
					int i=0;
					int v = 0;
					while(i<8)
					{
						v = pars.data.readUnsignedByte();
						//System.out.println("v " + v);
						size[i] = v;
						i++;
					}
					//si on est arrive a la fin de la partie des objets
					if(endSection(size))
					{
						//System.out.println("break?");
						break;
					}
					else
					{
						//sinon on lit toujours des objets
						ArrayList<Integer> section = new ArrayList<Integer>();
						section.add(size[4]);
						section.add(size[5]);
						section.add(size[6]);
						section.add(size[7]);
						int taille = pars.ConvertToDec2(section);
						
						donnees = new byte[taille];
						//System.out.println("taille "+taille);
						//lisons la section elle meme
						pars.data.read(donnees);
						results.add(donnees);
						//System.out.println("added");
						
					}
					
				}
				//on est au debut du fichier 
				//et on doit arrever d'abord aux sections Objet
				else
				{
					//tout au debut
					//lire ces 36 bytes d'un coup...
					byte[] begin = new byte[36];
					pars.data.read(begin);
					//lisons les 4 contenant la taille
					//begin = new byte[4];
					//pars.data.read(begin);
					int i=0;
					int v = 0;
					ArrayList<Integer> tab = new ArrayList<Integer>();
					while(i<4)
					{
						v = pars.data.readUnsignedByte();
						//System.out.println("v " + v);
						tab.add(v);
						i++;
					}
					//decodons la taille
					int taille = pars.ConvertToDec2(tab);
					//System.out.println("taille "+taille);
					begin = new byte[taille];
					pars.data.read(begin);
					
					begin = new byte[20];
					pars.data.read(begin);
					//on a lu tout le debut de fichier
					flagObj = true;
					//System.out.println("removed");
				}
			}
		} 
		catch (IOException e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//System.out.println("res size "+ results.size());
		return results;
	}
	
	
	//d'abord passer 36 bytes
	//lire 4 bytes de la taille
	//lire la section indique
	//passer 4 bytes
	//lire la taille (inutile)
	//lire 36 bytes
	public String[] ObjectReader(byte[] obj)
	{
		int pos = 40;
		byte[] size = new byte[4];
		size[0] = obj[39];
		size[1] = obj[38];
		size[2] = obj[37];
		size[3] = obj[36];
		ByteBuffer Bbuf = ByteBuffer.wrap(size);
		int t = Bbuf.getInt();
		String name = "";
		String Adresse = "";
		String[] results = new String[5];
		t=t+pos;
		while(pos<t-1)
		{
			name=name+(char)obj[pos];
			pos++;
		}
		pos++;//index du byte suivant la section Nom
		pos = pos+4;//position debut nouvelle taille
		//de toute facon on sait que la longueur de la section des coordonnees
		//et transformations vaut toujours 36
		pos=pos+4;//debut section position
		t= pos+36;
		byte[] tab = new byte[36];
		int ii=0;
		while(pos<t)
		{
			tab[ii]=obj[pos];//lecture correcte
			pos++;
			ii++;
		}
		String[] posit = this.Coordonnees(tab);
		//positions et coordonnees sont lues
		pos = pos+14;
		//depassons les 14 bytes inconnus
		
		//lire la taille
		size[0] = obj[pos+3];
		size[1] = obj[pos+2];
		size[2] = obj[pos+1];
		size[3] = obj[pos];
		Bbuf = ByteBuffer.wrap(size);
		t = Bbuf.getInt();
		//actualisons les index et la limite
		pos = pos+4;
		t= t+pos;
		pos = pos+8;
		while(pos<t-1)
		{
			Adresse=Adresse+(char)obj[pos];
			pos++;
		}
		
		System.out.println(" coord1 "+posit[0]);
		//System.out.println(" coord2 "+posit[1]);
		//System.out.println(" coord3 "+posit[2]);
		
		//System.out.println(" byte "+obj[pos]);
		//System.out.println(" t "+t);
		System.out.println(" name "+name);
		//System.out.println(" adresse "+Adresse);
		results[0] = name;
		results[1] = posit[0];
		results[2] = Adresse;
		results[3] = posit[1];
		results[4] = posit[2];
		
		
		return results;
	}
	
	public void csFormatConverter()
	{
		Parser pars = new Parser();
		try {
			
			ArrayList<byte[]> res = pars.ObjParser();
			pars.Output.writeBytes("[appendrandom]"+'\r'+'\n');
			pars.Output.writeBytes("        AppendRandomMaxRotation          = 0.000000, 0.000000, 0.000000"+'\r'+'\n');
			pars.Output.writeBytes("        AppendRandomMaxScale             = 1.000000, 1.000000, 1.000000"+'\r'+'\n');
			pars.Output.writeBytes("        AppendRandomMinRotation          = 0.000000, 0.000000, 0.000000"+'\r'+'\n');
			pars.Output.writeBytes("        AppendRandomMinScale             = 1.000000, 1.000000, 1.000000"+'\r'+'\n');
			pars.Output.writeBytes("        AppendRandomObjects_size         = 0"+'\r'+'\n');
			pars.Output.writeBytes(" "+'\r'+'\n');
			pars.Output.writeBytes("[guid]"+'\r'+'\n');
			pars.Output.writeBytes("        guid_g0                          = 0"+'\r'+'\n');
			pars.Output.writeBytes("        guid_g1                          = 0"+'\r'+'\n');
			pars.Output.writeBytes(" "+'\r'+'\n');
			pars.Output.writeBytes("[main]"+'\r'+'\n');
			pars.Output.writeBytes("        flags                            = 0"+'\r'+'\n');
			pars.Output.writeBytes("        objects_count                    = "+res.size()+'\r'+'\n');
	        pars.Output.writeBytes("        version                          = 0"+'\r'+'\n');
			pars.Output.writeBytes(" "+'\r'+'\n');
			pars.Output.writeBytes("[modif]"+'\r'+'\n');
			pars.Output.writeBytes("        name                             ="+'\r'+'\n');
			pars.Output.writeBytes("        time                             = 0"+'\r'+'\n');
			pars.Output.writeBytes(" "+'\r'+'\n');
			int ii = 0;
			for(byte[] i : res)
			{
				String[] obj = pars.ObjectReader(i);
				pars.Output.writeBytes("[object_"+ii+"]"+'\r'+'\n');
				pars.Output.writeBytes("        clsid                            = 2"+'\r'+'\n');
				pars.Output.writeBytes("        co_flags                         = 0"+'\r'+'\n');
				pars.Output.writeBytes("        flags                            = 0"+'\r'+'\n');
				pars.Output.writeBytes("        name                             = "+obj[0]+'\r'+'\n');
				pars.Output.writeBytes("        position                         = "+obj[1]+'\r'+'\n');
				pars.Output.writeBytes("        reference_name                   = "+obj[2]+'\r'+'\n');
				pars.Output.writeBytes("        rotation                         = "+obj[3]+'\r'+'\n');
				pars.Output.writeBytes("        scale                            = "+obj[4]+'\r'+'\n');
				pars.Output.writeBytes("        version                          = 18"+'\r'+'\n');
				pars.Output.writeBytes(" "+'\r'+'\n');
				ii++;
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally
		{
			try {
				pars.data.close();
				pars.Output.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}
		
		
	}
	
	public String[] Coordonnees(byte[] tab)
	{
		String[] res = new String[3];
		String Position = "";
		int i = 0;
		byte[] coord = new byte[4];
		while(i<12)
		{
			coord[0] = tab[i];
			coord[1] = tab[i+1];
			coord[2] = tab[i+2];
			coord[3] = tab[i+3];
			i=i+4;
			float f = this.ConvertToFloat(coord);
			if((f>this.maxX)&&(i==4))
				this.maxX = f;
			System.out.println(" max x "+this.maxX);
			if((f>this.maxY)&&(i==8))
				this.maxY = f;
			System.out.println(" max y "+this.maxY);
			if((f>this.maxZ)&&(i>8))
				this.maxZ = f;
			System.out.println(" max z "+this.maxZ);
			String f2s = this.versCs(""+f);
			if(Position =="")
				Position = Position + f2s;
			else
				Position = Position +", "+ f2s;
		}
		res[0]=Position;
		Position = "";
		while(i<24)
		{
			coord[0] = tab[i];
			coord[1] = tab[i+1];
			coord[2] = tab[i+2];
			coord[3] = tab[i+3];
			i=i+4;
			float f = this.ConvertToFloat(coord);
			String f2s = this.versCs(""+f);
			if(Position =="")
				Position = Position + f2s;
			else
				Position = Position +", "+ f2s;
		}
		res[1]=Position;
		Position = "";
		while(i<36)
		{
			coord[0] = tab[i];
			coord[1] = tab[i+1];
			coord[2] = tab[i+2];
			coord[3] = tab[i+3];
			i=i+4;
			float f = this.ConvertToFloat(coord);
			String f2s = this.versCs(""+f);
			if(Position =="")
				Position = Position + f2s;
			else
				Position = Position +", "+ f2s;
		}
		res[2]=Position;
		
		return res;
	}
	
	public boolean endSection(int[] tab)
	{
		int i = 0;
		int[] test = new int[8];
		test[0] = 1;
		test[1] = 16;
		test[2] = 0;
		test[3] = 0;
		test[4] = 2;
		test[5] = 0;
		test[6] = 0;
		test[7] = 0;
		while((i<8)&&(tab[i] == test[i]))
		{
			i++;
		}
		if(i==8)
			return true;
		else
			return false;
	}
	public String versCs(String s)
	{
		int t = s.indexOf(".");
		if((s.length()-(t+1)) >6)
		{
			int limit = t+1+ 6;
			//System.out.println(t);
			//System.out.println(s.length()-(t+1));
			s= s.substring(0, limit);
		}
		else
		{
			int rest = 6- (s.length()-(t+1));
			//System.out.println((s.length()-(t+1)));
			//System.out.println(rest);
			t=0;
			while(t<rest)
			{
				s=s+"0";
				t++;
			}
		}
		return s;
	}
	

}
